/* a simple program that prints numeric values of each input char */
/* compile with `cc -o printraw printraw.c'; exit with 'q' */
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <unistd.h>

struct termios origtios;

void
disableraw(void)
{
	tcsetattr(STDIN_FILENO, TCSAFLUSH, &origtios);
}

void
enableraw(void)
{
	struct termios raw = origtios;

	tcgetattr(STDIN_FILENO, &origtios);
	atexit(disableraw);

	raw = origtios;
	raw.c_iflag &= ~(BRKINT | ICRNL | INPCK | ISTRIP | IXON);
	raw.c_oflag &= ~OPOST;
	raw.c_cflag |= CS8;
	raw.c_lflag &= ~(ECHO | ICANON | IEXTEN | ISIG);

	tcsetattr(STDIN_FILENO, TCSAFLUSH, &raw);
}

int
main(void) {
	char c;

	enableraw();

	while (read(STDIN_FILENO, &c, 1) == 1 && c != 'q')
		if (iscntrl(c))
			printf("%3d ('\\0%o')\r\n", c, c);
		else
			printf("%3d ('%c')\r\n", c, c);

	return 0;
}
